[comment {-*- tcl -*- doctools manpage}]
[manpage_begin crimp_tk n 0.2]
[include include/module.inc]
[titledesc {CRIMP - Tk Photo Handling}]
[require Tcl 8.5]
[require Tk 8.5]
[require crimp::tk [opt 0.2]]
[keywords {Tk photo import} {Import tk photo}]
[keywords {Tk photo export} {Export tk photo}]
[description]

This package provides commands for the conversion of CRIMP images to
Tk photos image and vice versa, i.e. the export of images for display,
and import from a display.

[para] For a basic introduction of the whole CRIMP eco-system please
read the [term {CRIMP - Introduction to CRIMP}] (sic!).

The basic concepts used here, like images, image types, etc. are
described in the reference manpage for the [term {CRIMP - Foundation}].
We will not repeat them here, but assume that the reader knows them
already.

[para] In the overall architecture this package resides in the middle
layer of the system's architecture, between core and applications, as
shown at

[para][image arch_tk][para]

[para] The commands it provides all fall into the I/O category of the
general design.

[section {Tcl API}]

[list_begin definitions]

[call [cmd ::crimp] [method {read tk}] [arg photo]]

This method extends the [cmd {::crimp read}] ensemble. It takes the
name of a [term {Tk photo}] command and returns an image of type
[const rgba] containing the photo's contents.

[call [cmd ::crimp] [method {write 2tk}] [arg photo] [arg image]]

This method extends the [cmd {::crimp write}] ensemble. It takes two
arguments, the name of a [term {Tk photo}] command and an image, and
stores the image into the photo, overwriting the previous contents.

[para] The method returns the empty string.

[para] The supported image types are [const grey8], [const rgb], and
[const rgba].

[list_end]

[manpage_end]

